/*
   TODO: should the vcs_type only be on the Origins? And then have a primary key (forward key) on origins that currents can reference?
   TODO: change table naming to lowercase so it confirms to Postgres, the one and only true database
*/
CREATE TABLE IF NOT EXISTS Origins
(
    name       NVARCHAR(50),
    vcs_type   NVARCHAR(20),
    owner_name NVARCHAR(100),
    repo_name  NVARCHAR(100),
    PRIMARY KEY (name, vcs_type),
    FOREIGN KEY (vcs_type) REFERENCES VcsTypes (vcs_type)
);

CREATE TABLE IF NOT EXISTS Currents
(
    name     NVARCHAR(50),
    version  NVARCHAR(50),
    vcs_type NVARCHAR(20),
    contact  NVARCHAR(120),
    PRIMARY KEY (name, vcs_type),
    FOREIGN KEY (name, vcs_type) REFERENCES Origins (name, vcs_type),
    FOREIGN KEY (vcs_type) REFERENCES VcsTypes (vcs_type)
);

CREATE TABLE IF NOT EXISTS VcsTypes
(
    vcs_type     NVARCHAR(50),
    api_root_url NVARCHAR(100),
    PRIMARY KEY (vcs_type)
);

INSERT INTO VcsTypes (vcs_type, api_root_url)
VALUES ('github', 'https://api.github.com/')