use application::configuration::{ArgumentParser, Settings};
use application::console::Console;
use application::request::notification::EmailNotification;
use application::Application;

fn main() {
    let parser = ArgumentParser {};
    let settings = Settings::new(None).unwrap();
    let console = Console {};

    // TODO: maybe not clone here, but reference?
    let notification = EmailNotification {
        smtp_relay: settings.email.smtp_relay.clone(),
        smtp_username: settings.email.smtp_username.clone(),
        smtp_password: settings.email.smtp_password.clone(),
        from: settings.email.from.clone(),
    };
    let args = std::env::args().collect();
    let application = Application::new(&settings, &console, &notification, parser, args);

    application.run();
}
