use application::configuration::{ArgumentParser, Settings};
use application::console::Console;
use application::request::notification::EmailNotification;
use application::Application;
/*
   I use this as a test bench instead of running the binary from a terminal.
   TODO: i might change this to a test, that is muted somehow, but through configuration can be wired
         to a real SMTP server, so i can test the full flow of the binary
*/
fn main() {
    let parser = ArgumentParser {};
    let settings = Settings::new(None).unwrap();
    let console = Console {};

    let notification = EmailNotification {
        smtp_relay: settings.email.smtp_relay.clone(),
        smtp_username: settings.email.smtp_username.clone(),
        smtp_password: settings.email.smtp_password.clone(),
        from: settings.email.from.clone(),
    };

    let arguments_insert_origin = vec![
        String::from("release_checker"),
        String::from("register"),
        String::from("origin"),
        String::from("github"),
        String::from("gitea"),
        String::from("go-gitea"),
        String::from("gitea"),
    ];

    let application_insert_origin = Application::new(
        &settings,
        &console,
        &notification,
        parser,
        arguments_insert_origin,
    );

    application_insert_origin.run();

    let arguments_insert_current = vec![
        String::from("release_checker"),
        String::from("register"),
        String::from("current"),
        String::from("github"),
        String::from("gitea"),
        String::from("1.2.3"),
        String::from(&settings.email.from),
    ];

    let parser = ArgumentParser {};
    let application_insert_current = Application::new(
        &settings,
        &console,
        &notification,
        parser,
        arguments_insert_current,
    );

    application_insert_current.run();

    let parser = ArgumentParser {};
    let arguments_request = vec![String::from("release_checker"), String::from("request")];
    let application_do_request = Application::new(
        &settings,
        &console,
        &notification,
        parser,
        arguments_request,
    );

    application_do_request.run();
}
