#[test]
fn can_default_settings_be_loaded() {
    let _settings =
        application::configuration::Settings::new(None).expect("error when loading settings");
}

#[test]
fn database_settings_can_be_loaded() {
    let settings =
        application::configuration::Settings::new(None).expect("error when loading settings");
    assert_eq!("version_checker_db", settings.database.connection_string);
    assert!(!settings.database.in_memory);
}

#[test]
fn mail_settings_can_be_loaded() {
    let settings =
        application::configuration::Settings::new(None).expect("error when loading settings");
    assert_eq!("username", settings.email.smtp_username);
    assert_eq!("relay", settings.email.smtp_relay);
    assert_eq!("password", settings.email.smtp_password);
    assert_eq!("from@domain.tld", settings.email.from);

    assert!(!settings.database.in_memory);
}
